/*
 * Project: S.Ha.R.K.
 *
 * Coordinators: 
 *   Giorgio Buttazzo    <giorgio@sssup.it>
 *   Paolo Gai           <pj@gandalf.sssup.it>
 *
 * Authors     : 
 *   Giacomo Guidi       <giacomo@gandalf.sssup.it>
 *
 *
 * ReTiS Lab (Scuola Superiore S.Anna - Pisa - Italy)
 *
 * http://www.sssup.it
 * http://retis.sssup.it
 * http://shark.sssup.it
 */

/* Glue Layer for Linux PCI 2.6 Driver */
    
#include <kernel/kern.h>

extern int bttv_init_module(void);
extern void bttv_cleanup_module(void);

static int bttv_installed = FALSE;

/* Init the Linux BTTV 2.6 Driver */
int BTTV26_installed(void)
{
	return bttv_installed;
}

extern int videodev_init(void);

int BTTV26_init() {

	int res;

	if (bttv_installed == TRUE)
		return 0;

	videodev_init();

	res = bttv_init_module();

	if (res != 0) {
		sys_shutdown_message("ERROR: Cannot initialize BTTV\n");
		exit(1);
	}

	bttv_installed = TRUE;

	return 0;

}

int BTTV26_close() {

	if (bttv_installed == FALSE)
		return 0;

	bttv_cleanup_module();

	return 0;

}
