/*
 * Project: S.Ha.R.K.
 *
 * Coordinators: 
 *   Giorgio Buttazzo    <giorgio@sssup.it>
 *   Paolo Gai           <pj@gandalf.sssup.it>
 *
 * Authors     : 
 *   Giacomo Guidi       <giacomo@gandalf.sssup.it>
 *
 *
 * ReTiS Lab (Scuola Superiore S.Anna - Pisa - Italy)
 *
 * http://www.sssup.it
 * http://retis.sssup.it
 * http://shark.sssup.it
 */

/* Glue Layer for Linux PCI 2.6 Driver */
    
#include <kernel/kern.h>

extern int pci_direct_init(void);
extern int pcibios_init(void);
extern int pcibios_irq_init(void);
extern int pci_driver_init(void); 
extern int pci_legacy_init(void);
extern int pci_init(void);

static int pci_installed = FALSE;

/* Init the Linux PCI 2.6 Driver */
int PCI26_installed(void)
{
	return pci_installed;
}

int PCI26_init() {

	if (pci_installed == TRUE)
		return 0;

	pci_direct_init();

	pcibios_init();

	pci_driver_init(); 

	pci_legacy_init();
  
	pcibios_irq_init();

	pci_init();

	return 0;

}
