#ifndef __FTRACE_TYPES__
#define __FTRACE_TYPES__

/* FTrace types and structures */

#include <ll/sys/types.h>
#include <ll/i386/mem.h>
#include <ll/math.h>

#include "FTrace.h"

#define FTRACE_CHUNK_ID 0xFFAAFFBB

#define MAX_CHUNK 256

#define FTRACE_CHUNK_FLAG_FREE  0x01 /* Chunk is free */
#define FTRACE_CHUNK_FLAG_FULL  0x02 /* Chunk is full */
#define FTRACE_CHUNK_FLAG_CYC   0x00 /* Mode: Cyclical */
#define FTRACE_CHUNK_FLAG_JTN   0x04 /* Mode: Jump To Next */
#define FTRACE_CHUNK_FLAG_STOP  0x08 /* MOde: Stop if full */
#define FTRACE_CHUNK_FLAG_BUSY  0x10 /* Chunk is busy */
#define FTRACE_CHUNK_FLAG_NODEL 0x20 /* Chunk is protected from delete */
#define FTRACE_CHUNK_FLAG_COMPR 0x40 /* Chunk is compressed */

typedef BYTE FTrace_flags;

struct FTrace_Chunk {
  DWORD id;
  DWORD number;
  FTrace_flags flags;
  DWORD size;
  DWORD emergency_size;
  DWORD osd;
};

typedef struct FTrace_Chunk *FTrace_Chunk_Ptr;

#endif
